DROP TABLE TORNS IF EXISTS;
DROP TABLE COMBATS IF EXISTS;
DROP TABLE CHARACTERS IF EXISTS;
DROP TABLE ROLE_TYPES IF EXISTS;
DROP TABLE ENROLLMENTS IF EXISTS;
DROP TABLE USERS IF EXISTS;

CREATE TABLE USERS
(
    ID VARCHAR (50) NOT NULL,
    USERNAME VARCHAR(100) NOT NULL,
    -- Aquest camP contindrà el password xifrat.
    PASS VARCHAR(60)  NOT NULL,
    ALIAS VARCHAR(20)  NOT NULL,
    STAT BIT NOT NULL,
    -- Rol que tindrà l'usuari
    ROLE VARCHAR(10) NOT NULL,
    PRIMARY KEY (ID),
    CONSTRAINT USERNAME_UNIQUE UNIQUE (USERNAME)
);

CREATE TABLE ENROLLMENTS
(
    ID VARCHAR (50) NOT NULL,
    ID_USER VARCHAR (50) NOT NULL,
    TOKEN VARCHAR (100) NOT NULL,
    CREATION_DATE DATE NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (ID_USER) REFERENCES USERS(ID)
);

CREATE TABLE ROLE_TYPES
(
    ID VARCHAR (50) NOT NULL,
    ROLE_NAME VARCHAR(20)  NOT NULL,
    ATTACK_SUCCES INT,
    COUNTER_SUCCES INT,
    CAST_HEAL_SUCCES INT,
    INTERRUPT_SUCCES INT,
    SALUT INT,
    ARMADURA INT,
    MAL INT,
    HEAL INT,
    PRIMARY KEY (ID)
)

CREATE TABLE CHARACTERS
(
    ID VARCHAR (50) NOT NULL,
    ID_USER VARCHAR (50) NOT NULL,
    ID_CHAR_TYPE VARCHAR (50) NOT NULL,
    NOM VARCHAR(20)  NOT NULL,
    SALUT INT,
    ARMADURA INT,
    MAL INT,
    HEAL INT,
    PRIMARY KEY (ID),
    FOREIGN KEY (ID_USER) REFERENCES USERS(ID),
    FOREIGN KEY (ID_CHAR_TYPE) REFERENCES ROLE_TYPES(ID),
    CONSTRAINT NAME_UNIQUE UNIQUE (NOM)
);

CREATE TABLE COMBATS
(
    ID VARCHAR (50) NOT NULL,
    ID_CHAR_1 VARCHAR (50) NOT NULL,
    ID_CHAR_2 VARCHAR (50) NOT NULL,
    SALUT_INIT_CHAR1 INT NOT NULL,
    SALUT_INIT_CHAR2 INT NOT NULL,
    SALUT_ACTUAL_ROL1 INT,
    SALUT_ACTUAL_CHAR2 INT,
    STAT INT NOT NULL,
    WINNER INT,
    PRIMARY KEY (ID)
);

CREATE TABLE TORNS
(
    ID VARCHAR (50) NOT NULL,
    ID_COMBAT VARCHAR (50) NOT NULL,
    ACCIO_ROL1 INT NOT NULL,
    ACCIO_ROL1_SUCCES BIT NOT NULL,
    ACCIO_ROL1_VALUE INT,
    ACCIO_CHAR2 INT NOT NULL,
    ACCIO_CHAR2_SUCCES BIT NOT NULL,
    ACCIO_CHAR2_VALUE INT,
    PRIMARY KEY (ID),
    FOREIGN KEY (ID_COMBAT) REFERENCES COMBATS(ID)
);



